/*csphot returns photoionization cross section from opacity stage using std pointers */
#include "cddefines.h"
#include "opac.h"
#include "csphot.h"

double csphot(long int inu, 
  long int ithr, 
  long int iofset)
{
	double csphot_v;

#	ifdef DEBUG_FUN
	fputs( "<+>csphot()\n", debug_fp );
#	endif

	/* function to facilitate addressing opacity array
	 * INU is pointer to frequency where opacity is to be evaluated
	 * ITHR is pointer to threshold
	 * IOFSET is offset as defined in opac0
	 * */
	csphot_v = opac.OpacStack[inu-ithr+iofset-1];


#	ifdef DEBUG_FUN
	fputs( " <->csphot()\n", debug_fp );
#	endif
	return( csphot_v );
}

