/*DumpLine print various information about an emission line vector, 
 * used in debugging, print to std out, ioQQQ */
#include <string.h>
#include "cddefines.h"
#include "taulines.h"
#include "phycon.h"
#include "chlinelbl.h"
#include "texcline.h"
#include "dumpline.h"

void DumpLine(EmLine * t)
{
	char chLbl[11];

#	ifdef DEBUG_FUN
	fputs( "<+>DumpLine()\n", debug_fp );
#	endif

	/* routine to print contents of line arrays */
	strcpy( chLbl, chLineLbl(t) );

	fprintf( ioQQQ, 
		" Dump of %10.10s te=%.2e eden=%.2e CS=%8.2e Aul=%8.2e Texc=%.2e cool,heat=%.2e %.2e\n", 
	  chLbl, 
	  phycon.te, 
	  phycon.eden, 
	  t->cs, 
	  t->Aul, 
	  TexcLine(t), 
	  t->cool, 
	  t->heat );

	fprintf( ioQQQ, 
		"  Tin%.2e Tout%.2e EscP%.2e DesP%.2e Pump%.2e OTS%.2e PopL,U%.2e %.2e\n", 
	  t->TauIn, 
	  t->TauTot, 
	  t->Pesc, 
	  t->Pdest, 
	  t->pump, 
	  t->ots, 
	  t->PopLo, 
	  t->PopHi );

#	ifdef DEBUG_FUN
	fputs( " <->DumpLine()\n", debug_fp );
#	endif
	return;
}

