/* GetQuote get any name between double quotes off command line
 * return string as chLabel, is null terminated */
#include <string.h>
#include "cddefines.h"
#include "getquote.h"
#include "input.h"

void GetQuote(char *chLabel,	/* we will generate a label and stuff it here */
	      char *chCard )	/* local capd line, we will blank this out */	
{
	char *i0,       /* pointer to first " */
	  *i1,          /* pointer to second ", name is in between */
	  *iLoc;        /* pointer to first " in local version of card in calling routine */
	size_t len;

#	ifdef DEBUG_FUN
	fputs( "<+>GetQuote()\n", debug_fp );
#	endif

	/*label within quotes returned within chLabel
	 *label in line image is set to blanks when complete */

	/* find start of string, string must begin and end with double quotes */
	/* get pointer to first quote */
	i0 = strchr( input.chOrgCard,'\"' );

	if( i0 != NULL ) {
		/* get pointer to next quote */
		/*i1 = strrchr( input.chOrgCard,'\"' );*/
		i1 = strchr( i0+1 ,'\"' );
	}
	else {
		i1 = NULL;
	}

	/* check that pointers were not NULL */
	/* >>chng 00 Apr 27, check for i0 and i1 equal not needed anymore, by PvH */
	if( i0 == NULL || i1 == NULL )
	{
		fprintf( ioQQQ, 
			" A filename or label must be specified within double quotes, but no quotes were encountered on this command.\n" );
		fprintf( ioQQQ, " Name must be surrounded by exactly two double quotes, like \"name.txt\". \n" );
		fprintf( ioQQQ, " The line image follows:\n" );
		fprintf( ioQQQ, " %s\n", input.chOrgCard);
		fprintf( ioQQQ, " Sorry\n" );
		puts( "[Stop in getquote]" );
		cdEXIT(1);
	}

	/* now copy the text inbetween quotes */
	len = (size_t)(i1-i0-1);
	strncpy(chLabel,i0+1,len);
	/* strncpy doesn't terminate the label */
	chLabel[len] = '\0';

	/* get pointer to first quote in local copy of line image in calling routine */
	iLoc = strchr( chCard ,'\"' );
	if( iLoc == NULL )
	{
		fprintf( ioQQQ, " Insanity in GetQuote - line image follows:\n" );
		fprintf( ioQQQ, " %s\n", input.chOrgCard);
		puts( "[Stop in getquote]" );
		cdEXIT(1);
	}

	/* >>chng 97 july 1, blank out label once finished, to not be picked up later */
	/* >>chng 00 Apr 27, erase quotes as well, so that we can find second label, by PvH */
	while( i0 <= i1 )
	{
		*i0 = ' ';
		*iLoc = ' ';
		++i0;
		++iLoc;
	}

#	ifdef DEBUG_FUN
	fputs( " <->GetQuote()\n", debug_fp );
#	endif
	return;
}

