/*outsum sum outward continuum beams */
#include "cddefines.h"
#include "physconst.h"
#include "rfield.h"
#include "outsum.h"

void outsum(double *outtot, 
  double *outin, 
  double *outout)
{
	long int i;

#	ifdef DEBUG_FUN
	fputs( "<+>outsum()\n", debug_fp );
#	endif

	*outin = 0.;
	*outout = 0.;
	for( i=0; i < rfield.nflux; i++ )
	{
		/* N.B. in following en1ryd prevents overflow */
		*outin += rfield.anu[i]*(rfield.flux[i]*EN1RYD);
		*outout += rfield.anu[i]*(rfield.outlin[i] + rfield.ConOutInter[i]+rfield.ConOutRecInter[i])*
		  EN1RYD;
	}

	*outtot = *outin + *outout;

#	ifdef DEBUG_FUN
	fputs( " <->outsum()\n", debug_fp );
#	endif
	return;
}

