/*rdsum parse print line sum command to enter set of lines into sum  */
#include <string.h>
#include "cddefines.h"
#include "cddrive.h"
#include "fourpi.h"
#include "linesave.h"
#include "ffmtread.h"
#include "readar.h"
#include "caps.h"
/* this is the limit to the number of lines we can save */
#define	NRDSUM	300L
#include "rdsum.h"

void rdsum(double *sum, 
  char *chDo)
{
	char chCCap[81], 
	  chCard[81];
	/*static char chSMLab[NRDSUM][5];*/
	static char **chSMLab;
	int lgEND, 
	  lgEOF, 
	  lgEOL;
	long int i;
	/* remember whether we have been called before */
	static int lgFirst=TRUE;
	/*static long int lamsm[NRDSUM], */
	static long *lamsm, 
	  nlsum;
	double absint, 
	  relint;

#	ifdef DEBUG_FUN
	fputs( "<+>rdsum()\n", debug_fp );
#	endif

	if( strncmp(chDo,"READ",4) == 0 )
	{
		if( !lgFirst )
		{
			/* error - more than one read in input stream */
			fprintf(ioQQQ," more than one print line sum has appeared - only one allowed.\n");
			fprintf(ioQQQ," Sorry.\n");
			puts( "[Stop in rdsum]" );
			cdEXIT(1);
		}
		else
		{
			/* malloc spae */
			lgFirst = FALSE ;
			if( (lamsm = ((long *)malloc( sizeof(long )*NRDSUM )) ) == NULL )
			{
				fprintf(ioQQQ," error mallocing lamsm in rdsum.\n");
				fprintf(ioQQQ," Sorry.\n");
				puts( "[Stop in rdsum]" );
				cdEXIT(1);
			}
			/* create space for the array of labels*/
			if( (chSMLab = ((char **)malloc(NRDSUM*sizeof(char *)))) == NULL )
			{
				fprintf(ioQQQ," rdsum could not malloc chSMLab\n");
				puts( "[Stop in rdsum]" );
				cdEXIT(1);
			}
			for( i=0; i<NRDSUM; ++i )
			{
				if( (chSMLab[i] = ((char *)malloc(5*sizeof(char )))) == NULL )
				{
					fprintf(ioQQQ," rdsum could not malloc2 chSMLab\n");
					puts( "[Stop in rdsum]" );
					cdEXIT(1);
				}
			}
		}
		/* now read in lines */
		nlsum = 0;
		lgEND = FALSE;
		while( !lgEND )
		{
			readar(chCard,&lgEOF);
			if( lgEOF )
			{
				fprintf( ioQQQ, " Hit EOF while reading line list; use END to end list.\n" );
				puts( "[Stop in rdsum]" );
				cdEXIT(1);
			}
			strcpy( chCCap, chCard );
			caps(chCCap);

			if( strncmp(chCCap , "END" , 3) != 0 )
			{
				if( nlsum >= NRDSUM )
				{
					fprintf( ioQQQ, 
						" Too many lines have been entered; the limit is %li.  Increase NRDSUM in rdsum.\n", 
					  NRDSUM );
					puts( "[Stop in rdsum]" );
					cdEXIT(1);
				}

				/*  order on line is label (col 1-4), wavelength */
				strncpy( chSMLab[nlsum], chCCap , 4 );
				chSMLab[nlsum][4] = 0;
				i = 5;
				lamsm[nlsum] = (long int)FFmtRead(chCard,&i,76,&lgEOL);
				++nlsum;
			}
			else
			{
				lgEND = TRUE;
			}
		}
	}

	else if( strncmp(chDo," SUM" ,  4) == 0 )
	{
		*sum = 0.;
		/* this can be called during setup mode, in which case we do nothing */
		if( LineSave.ipass <= 0 )
		{ 
#			ifdef DEBUG_FUN
			fputs( " <->rdsum()\n", debug_fp );
#			endif
			return;
		}

		for( i=0; i < nlsum; i++ )
		{
			if( cdLine((char*)chSMLab[i],lamsm[i],&relint,&absint) )
			{
				absint = pow(10.,absint - fourpi.pirsq);
				*sum += absint;
			}

			else
			{
				fprintf( ioQQQ, " RDSUM could not fine line %4.4s%5ld\n", 
				  chSMLab[i], lamsm[i] );
				puts( "[Stop in rdsum]" );
				cdEXIT(1);
			}
		}
	}

	else
	{
		fprintf( ioQQQ, " unrecognized key for RDSUM=%4.4s\n", 
		  chDo );
		puts( "[Stop in rdsum]" );
		cdEXIT(1);
	}

#	ifdef DEBUG_FUN
	fputs( " <->rdsum()\n", debug_fp );
#	endif
	return;
}
